<template>
  <div>
      <div class="font-light mt-2" >{{ attribute[0].name }}:

      <span class="pr-4 text-gray-800 font-semibold lowercase" v-if="attributeSelected[attribute[0].name]">
        {{ attributeSelected[attribute[0].name].name }}
      </span>
    </div>

    <div class="flex flex-wrap">
      <div class="flex flex-wrap my-2">
        <div class="" v-for="attrib in attribute[0].values" :key="attrib.id">

          <div
            :class="{
                'border-2 border-indigo-700 shadow-md': attributeSelected[attribute[0].name]
                  && attributeSelected[attribute[0].name].id === attrib.id,
                'border': attributeSelected[attribute[0].name] && attributeSelected[attribute[0].name].id !== attrib.id,
                'w-20 h-24': attribute[0].name === 'color',
                'opacity-50': attrib.disabled
              }"
            class="flex flex-col hover:border-indigo-700 border-gray-400 rounded-lg py-1 my-1 mx-1 cursor-pointer transition-all duration-500 ease-in-out"
            @click.prevent="selectAttribute(attrib)"
          >
            <div v-if="attrib.image">
              <div class="flex justify-center my-2">
                <img class="w-12 h-12" :src="`${apiStorage}/imgs/products/${attrib.image}`" :alt="attrib.name">
              </div>
            </div>

            <div class="w-full h-full text-center px-4 text-xs truncate">{{ attrib.name }}</div>
          </div>
        </div>
        </div>
      </div>
    </div>
</template>
<script>
import VueSelect from '@/components/form/VueSelect'

export default {
  auth: 'guest',

  components: {
    VueSelect
  },
  props: {

      value: {
          required: false,
          default: ''
      },
      attribute: {
        required: true,
        type: Array
      }
  },

  watch: {
    attributeSelected(value) {
      // console.log(value)
    }
  },

  data() {
    return {
      apiStorage: process.env.API_URL + '/storage',
      attributeSelected: [],
      avaliablesVariations: [],
      attributesAvaliables: []
    }
  },

  mounted() {
    if (this.selectedVariation) {
      Object.keys(this.selectedVariation.attributes).map((variant, key) => {
        if (this.selectedVariation.attributes[variant][0].attribute.name === this.attribute[0].name) {
          this.selectAttribute(this.selectedVariation.attributes[variant][0])
        }
      })
    }
  },

  computed: {
      selectedVariationId () {
        if(this.value){
            if (!this.findVariation(this.value.id)){
                return ''
            }
            return this.value.id
        }
        return ''
      },

      product() {
        return this.$store.state.product.parent
      },

      selectedVariation() {
        return this.$store.state.product.variant
      }
  },
  methods: {
    selectAttribute(attributeValue) {
      this.attributeSelected = Object.assign({...this.attributeSelected}, {[this.attribute[0].name]: { id: attributeValue.id, attribute_id: attributeValue.product_attribute_id, attribute_name: this.attribute[0].name, name: attributeValue.name, disabled: false } })
      this.$emit('variationSelected', this.attributeSelected)
    },

    changed(event){
        this.$emit('input', this.findVariation(event.target.value))
    },
    findVariation(id) {
        let variation = this.variations.find(v => v.id == id)

        if (typeof variation === 'undefined') {
            return null
        }

        return variation
    }
  }
}
</script>
